<?php

namespace App\Http\Requests\Admin;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class SellerRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('cobons'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'discount_type'=>'required|in:1,2',
            'discount_amount'=>'required|numeric',
            'start_date'=>'required|date',
            'end_date'=>'required|date|after:start_date',
            'count'=>'required|numeric',
            'status_user' => 'required|in:all,specific',
            'seller_id' => 'required|exists:users,id',
            'code'=> [
                "required",
                Rule::unique('cobons')->ignore($this->seller? $this->seller : 0, 'id')
            ],
        ];

        foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=> 'required',
            ];
            $rules= array_merge($rules, $lang_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('cobons');
        $attributes= [
            'discount_type'=>  __('cobons.discount_type'),
            'discount_amount'=>  __('cobons.discount_amount'),
            'start_date'=>  __('cobons.start_date'),
            'end_date'=>  __('cobons.end_date'),
            'code'=>  __('cobons.code'),
            'count'=>  __('cobons.count'),
            'image'=>  __('cobons.image'),
            'max'=>__('sellers.max'),
            'seller_id'=>__('cobons.seller_id'),

        ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local => $cobon->{'title_'.$lang->local} ?? __('cobons.name').' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
